<template>
    <v-dialog v-model="showDialog" max-width="600px">
        <v-card tile style="overflow: hidden;">
            <v-toolbar flat dark color="black">
                <v-toolbar-title class="title">Subcategorías de {{ auxIngredient.name }}</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                    <v-btn icon dark @click="closeWindow">
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </v-toolbar-items>
            </v-toolbar>
            <v-container class="px-7">
                <v-row>
                    <v-col>
                        <v-form v-model="valid" lazy-validation ref="form">
                            <v-row>
                                <v-col>
                                    <v-text-field
                                        label="Limitar Extras"
                                        type="number"
                                        :value="Number(auxIngredient.maxAmount)"
                                        :rules="[
                                            v => v >= 0 || 'Debe ser mayor o igual a 0',
                                            v => v <= extras.length || 'No puede ser mayor a el número de subcategorías'
                                        ]"
                                        @input="auxIngredient.maxAmount = Number($event)"
                                        style="position: absolute; z-index: 2; width: 40%;"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                        </v-form>
                        <ExtraIngredient
                            :ingredient="this.ingredient"
                            :extrasFromFire="extras"
                            :menu-id="menuId"
                            :langsMenu="langsMenu"
                            @saveExtra="saveExtra"
                            @deleteExtra="deleteExtra"
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-spacer></v-spacer>
                    <v-btn class="add" :disabled="!valid" depressed @click="saveIngredient">Guardar</v-btn>
                </v-row>
            </v-container>
        </v-card>
    </v-dialog>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { Ingredient as IngredientModel } from '@/model/menu/Ingredient';
import { ExtraIngredient as ExtraIngredientModel } from '@/model/menu/ExtraIngredient';
import { LangMenu } from '@/model/menu/LangMenu';
import { db } from '@/config/firebase';
import { INGREDIENTS, MENUS, INGREDIENT_EXTRA } from '@/config/collectionsName';
import { serializeExtraIngredient } from '@/config/serializables';
import ExtraIngredient from '@/components/menu/ExtraIngredient.vue';
import { LangText } from '@/model/LangText';
import { DishService } from '@/services/DishService';
import { Price as PriceModel } from '@/model/menu/Price';

@Component({ components: { ExtraIngredient } })
export default class ExtraIngredients extends Vue {
    @Prop({ required: true })
    ingredient!: IngredientModel;
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ default: false })
    showDialog!: boolean;
    @Prop({ required: true })
    menuId!: string;

    tab = null;
    valid = true;
    auxIngredient: IngredientModel = new IngredientModel('', 0, '', '', false);
    extrasFromFire: ExtraIngredientModel[] = [];
    dishService = new DishService();

    closeWindow() {
        this.$emit('setIngredientModal', false);
        this.auxIngredient = Object.assign(this.auxIngredient, this.ingredient);
    }

    saveIngredient() {
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid) {
            this.$emit('saveIngredient', this.auxIngredient);
            this.closeWindow();
        }
    }

    get extras() {
        return this.extrasFromFire;
    }

    async saveExtra(
        ingredientId: string,
        extraIngredient: ExtraIngredientModel,
        langsExtra: LangText[],
        pricesExtra: PriceModel[]
    ) {
        if (extraIngredient.id) {
            await this.dishService.updateExtraIngredient(
                this.menuId,
                ingredientId,
                extraIngredient,
                langsExtra,
                pricesExtra
            );
            this.$emit('setMessage', 'SUBCATEGORÍA ACTUALIZADA', 'success', true);
            return;
        }
        await this.dishService.createExtraIngredient(
            this.menuId,
            ingredientId,
            extraIngredient,
            langsExtra,
            pricesExtra
        );
        this.$emit('setMessage', 'SUBCATEGORÍA CREADA', 'success', true);
        return;
    }

    async deleteExtra(menuId: string, ingredientId: string, extraIngredientId: string, extraIngredientName: string) {
        if (confirm(`¿Deseas eliminar esta subcategoría ${extraIngredientName}?`)) {
            await this.dishService.deleteExtra(menuId, ingredientId, extraIngredientId);
            this.$emit('setMessage', 'SUBCATEGORÍA ELIMINADA', 'info', true);
            return;
        }
    }

    @Watch('ingredient')
    async onExtrasChange(newIngredient: IngredientModel | null) {
        this.extrasFromFire = [];
        if (newIngredient && newIngredient.id) {
            const ref = db
                .collection(MENUS)
                .doc(this.menuId)
                .collection(INGREDIENTS)
                .doc(this.ingredient.id);
            await this.$bind('extrasFromFire', ref.collection(INGREDIENT_EXTRA), {
                serialize: serializeExtraIngredient
            });
        }
        this.auxIngredient = Object.assign(this.auxIngredient, this.ingredient);
    }
}
</script>

<style type="text/css"></style>
